<?php
/**
 * Artist Painter Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package artist_painter
 */

if( ! function_exists( 'artist_painter_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function artist_painter_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Artist_Painter_Control_Sortable' ); 
    

    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'artist-painter' );
    }
	
    /* Option list of all post */	
    $artist_painter_options_posts = array();
    $artist_painter_options_posts_obj = get_posts('posts_per_page=-1');
    $artist_painter_options_posts[''] = esc_html__( 'Choose Post', 'artist-painter' );
    foreach ( $artist_painter_options_posts_obj as $artist_painter_posts ) {
    	$artist_painter_options_posts[$artist_painter_posts->ID] = $artist_painter_posts->post_title;
    }
    
    /* Option list of all categories */
    $artist_painter_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $artist_painter_option_categories = array();
    $artist_painter_category_lists = get_categories( $artist_painter_args );
    $artist_painter_option_categories[''] = esc_html__( 'Choose Category', 'artist-painter' );
    foreach( $artist_painter_category_lists as $artist_painter_category ){
        $artist_painter_option_categories[$artist_painter_category->term_id] = $artist_painter_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'artist-painter' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'artist-painter' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'artist-painter' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'artist-painter' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'artist-painter'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '70', 
    ));

    $wp_customize->add_setting( 'artist_painter_site_title_size', array(
        'default'           => 20, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'artist_painter_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'artist-painter' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'artist_painter_post_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'artist-painter' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'artist-painter' ),
        ) 
    );

    /** Post Layouts */  
    $wp_customize->add_section(
        'artist_painter_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'artist-painter' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_post_settings',
        )
    );

    $wp_customize->add_setting('artist_painter_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'artist_painter_sanitize_post_layout',
    ));

    $wp_customize->add_control('artist_painter_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'artist-painter'),
        'section'  => 'artist_painter_post_layout_section',
        'settings' => 'artist_painter_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'artist-painter'),
            'left-sidebar'   => __('Left Sidebar', 'artist-painter'),
            'one-column'   => __('One Column', 'artist-painter'),
            'three-column'   => __('Three Columns', 'artist-painter'),
            'four-column'   => __('Four Columns', 'artist-painter'),
            'grid-layout'   => __('Grid Layout', 'artist-painter')
        ),
    ));

     /** Post Layouts Ends */

    /** Blog Content Alignment */
    $wp_customize->add_setting('artist_painter_blog_layout_option', array(
        'default'           => 'Left',
        'sanitize_callback' => 'artist_painter_sanitize_choices',
    ));

    $wp_customize->add_control('artist_painter_blog_layout_option', array(
        'label'    => __('Post Content Alignment', 'artist-painter'),
        'section'  => 'artist_painter_post_layout_section',
        'settings' => 'artist_painter_blog_layout_option',
        'type'     => 'select',
        'choices'  => array(
		   'Left'     => __('Left', 'artist-painter'),
		   'Center'     => __('Center', 'artist-painter'),
		   'Right'     => __('Right', 'artist-painter'),
        ),
    ));
     
    /** Post Settings */
    $wp_customize->add_section(
        'artist_painter_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'artist-painter' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'artist_painter_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'artist-painter' ),
            'section'     => 'artist_painter_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'artist_painter_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'artist-painter' ),
            'section'     => 'artist_painter_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'artist_painter_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'artist-painter' ),
            'section'     => 'artist_painter_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'artist_painter_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'artist-painter' ),
            'section'     => 'artist_painter_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post ReadMore control */
     $wp_customize->add_setting( 'artist_painter_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'artist_painter_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'artist_painter_read_more_setting', array(
        'type'        => 'checkbox',
        'section'     => 'artist_painter_post_settings', 
        'label'       => __( 'Display Read More Button', 'artist-painter' ),
    ) );

    $wp_customize->add_setting('artist_painter_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'artist_painter_sanitize_sortable',
    ));
    $wp_customize->add_control(new Artist_Painter_Control_Sortable($wp_customize, 'artist_painter_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'artist-painter'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'artist-painter') ,
        'section' => 'artist_painter_post_settings',
        'choices' => array(
            'heading' => __('heading', 'artist-painter') ,
            'author' => __('author', 'artist-painter') ,
            'featured-image' => __('featured-image', 'artist-painter') ,
            'content' => __('content', 'artist-painter') ,
            'button' => __('button', 'artist-painter') ,
        ) ,
    )));

    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'artist_painter_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'artist-painter' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'artist_painter_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'artist-painter' ),
            'section'     => 'artist_painter_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'artist_painter_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'artist-painter' ),
            'section'     => 'artist_painter_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    //Global Color
    $wp_customize->add_section(
        'artist_painter_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'artist-painter' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_general_settings',
        )
    );

    $wp_customize->add_setting('artist_painter_primary_color', array(
        'default'           => '#C9241E',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'artist_painter_primary_color', array(
        'label'    => __('Theme Primary Color', 'artist-painter'),
        'section'  => 'artist_painter_global_color',
        'settings' => 'artist_painter_primary_color',
    )));    

    $wp_customize->add_setting('artist_painter_second_color', array(
        'default'           => '#EF912D',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'artist_painter_second_color', array(
        'label'    => __('Theme Secondary Color', 'artist-painter'),
        'section'  => 'artist_painter_global_color',
        'settings' => 'artist_painter_second_color',
    )));

    /** Single Post Settings Ends */

    // Typography Settings Section
    $wp_customize->add_section('artist_painter_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'artist-painter'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'artist_painter_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'artist-painter'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('artist_painter_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'artist_painter_sanitize_choicess',
    ));
    $wp_customize->add_control('artist_painter_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'artist-painter'),
        'section' => 'artist_painter_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('artist_painter_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'artist_painter_sanitize_choicess',
    ));
    $wp_customize->add_control('artist_painter_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'artist-painter'),
        'section' => 'artist_painter_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'artist_painter_general_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'artist-painter' ),
            'description' => esc_html__( 'Customize General Settings', 'artist-painter' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'artist_painter_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'artist-painter' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'artist_painter_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'artist-painter' ),
            'section'     => 'artist_painter_general_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('artist_painter_loader_layout_setting', array(
        'default' => 'load',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    // Add control for loader layout
    $wp_customize->add_control('artist_painter_loader_layout_control', array(
        'label' => __('Preloader Layout', 'artist-painter'),
        'section' => 'artist_painter_general_settings',
        'settings' => 'artist_painter_loader_layout_setting',
        'type' => 'select',
        'choices' => array(
            'load' => __('Preloader 1', 'artist-painter'),
            'load-one' => __('Preloader 2', 'artist-painter'),
            'ctn-preloader' => __('Preloader 3', 'artist-painter'),
        ),
    ));

    /** Header Section Settings */
    $wp_customize->add_section(
        'artist_painter_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'artist-painter' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_home_page_settings',
        )
    );

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'artist_painter_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'artist-painter' ),
            'section'     => 'artist_painter_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    /** WISHLIST URL */
    $wp_customize->add_setting(
        'artist_painter_wishlist_url',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_wishlist_url',
        array(
            'label' => esc_html__( 'Wishlist URL', 'artist-painter' ),
            'section' => 'artist_painter_header_section_settings',
            'type' => 'url',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'artist_painter_menu_font_weight', array(
        'default'           => '400',
        'sanitize_callback' => 'artist_painter_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'artist_painter_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'artist-painter' ),
        'section'  => 'artist_painter_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'artist-painter' ),
            '200' => __( '200 - Extra Light', 'artist-painter' ),
            '300' => __( '300 - Light', 'artist-painter' ),
            '400' => __( '400 - Normal', 'artist-painter' ),
            '500' => __( '500 - Medium', 'artist-painter' ),
            '600' => __( '600 - Semi Bold', 'artist-painter' ),
            '700' => __( '700 - Bold', 'artist-painter' ),
            '800' => __( '800 - Extra Bold', 'artist-painter' ),
            '900' => __( '900 - Black', 'artist-painter' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'artist_painter_menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'artist_painter_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'artist_painter_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'artist-painter' ),
        'section'  => 'artist_painter_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'artist-painter' ),
            'capitalize' => __( 'Capitalize', 'artist-painter' ),
            'uppercase'  => __( 'Uppercase', 'artist-painter' ),
            'lowercase'  => __( 'Lowercase', 'artist-painter' ),
        ),
    ) );

    // Menu Hover Style	
    $wp_customize->add_setting('artist_painter_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'artist_painter_sanitize_choices'
	));
	$wp_customize->add_control('artist_painter_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','artist-painter'),
		'section' => 'artist_painter_header_section_settings',
		'choices' => array(
         'None' => __('None','artist-painter'),
         'Zoom In' => __('Zoom In','artist-painter'),
      ),
	));

    $wp_customize->add_setting( 
        'artist_painter_header_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'artist_painter_header_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(ARTIST_PAINTER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'artist_painter_header_section_settings'
        )
    );

    /** Socail Section Settings */
    $wp_customize->add_section(
        'artist_painter_social_section_settings',
        array(
            'title' => esc_html__( 'Social Media Section Settings', 'artist-painter' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_home_page_settings',
        )
    );

    /** Socail Section control */
    $wp_customize->add_setting( 
        'artist_painter_social_icon_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'artist-painter' ),
            'section'     => 'artist_painter_social_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'artist_painter_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_social_link_1',
        array(
            'label' => esc_html__( 'Facebook Link', 'artist-painter' ),
            'section' => 'artist_painter_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'artist_painter_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_social_link_2',
        array(
            'label' => esc_html__( 'Twitter Link', 'artist-painter' ),
            'section' => 'artist_painter_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'artist_painter_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_social_link_3',
        array(
            'label' => esc_html__( 'Instagram Link', 'artist-painter' ),
            'section' => 'artist_painter_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 5 */
    $wp_customize->add_setting(
        'artist_painter_social_link_5',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_social_link_5',
        array(
            'label' => esc_html__( 'Youtube Link', 'artist-painter' ),
            'section' => 'artist_painter_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'artist_painter_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_social_link_4',
        array(
            'label' => esc_html__( 'Pintrest Link', 'artist-painter' ),
            'section' => 'artist_painter_social_section_settings',
            'type' => 'url',
        )
    );

    $wp_customize->add_setting( 
        'artist_painter_social_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'artist_painter_social_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(ARTIST_PAINTER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'artist_painter_social_section_settings'
        )
    );

    /** Socail Section Settings End */

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'artist_painter_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'artist-painter' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'artist-painter' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'artist_painter_slider_section_settings',
        array(
            'title' => esc_html__( 'Banner Section Settings', 'artist-painter' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'artist_painter_slider_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_slider_setting',
        array(
            'label'       => __( 'Show Banner', 'artist-painter' ),
            'section'     => 'artist_painter_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

        // Section Text
    $wp_customize->add_setting('artist_painter_slider_text_extra', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('artist_painter_slider_text_extra', 
        array(
        'label'       => __('Banner Extra Title', 'artist-painter'),
        'section'     => 'artist_painter_slider_section_settings',   
        'settings'    => 'artist_painter_slider_text_extra',
        'type'        => 'text'
        )
    );

    // Section Text
    $wp_customize->add_setting('artist_painter_slider_banner_heading', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('artist_painter_slider_banner_heading', 
        array(
        'label'       => __('Banner Title', 'artist-painter'),
        'section'     => 'artist_painter_slider_section_settings',   
        'settings'    => 'artist_painter_slider_banner_heading',
        'type'        => 'text'
        )
    );

    // Section Text
    $wp_customize->add_setting('artist_painter_slider_banner_content', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('artist_painter_slider_banner_content', 
        array(
        'label'       => __('Banner Content', 'artist-painter'),
        'section'     => 'artist_painter_slider_section_settings',   
        'settings'    => 'artist_painter_slider_banner_content',
        'type'        => 'text'
        )
    );

    // slider button text
	$wp_customize->add_setting('artist_painter_button_text', 
    array(
	    'default'           => 'Explore Gallery',
        'type'              => 'theme_mod',
	    'sanitize_callback' => 'sanitize_text_field',
	    'capability'        => 'edit_theme_options',
	));
	$wp_customize->add_control('artist_painter_button_text', 
    array(
        'label'    => __('Banner Button Text', 'artist-painter'),
	    'settings' => 'artist_painter_button_text',
	    'section'  => 'artist_painter_slider_section_settings',
	    'type'     => 'text',
	));

    // slider button Url
    $wp_customize->add_setting('artist_painter_slider_btn_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'esc_url_raw'
        )
    );

    $wp_customize->add_control('artist_painter_slider_btn_url', 
        array(
        'label'       => __('Banner Button URL', 'artist-painter'),
        'section'     => 'artist_painter_slider_section_settings',   
        'settings'    => 'artist_painter_slider_btn_url',
        'type'        => 'url'
        )
    );

    //Banner Image Settings
    $wp_customize->add_setting('artist_painter_slider_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );

    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'artist_painter_slider_background_image',
            array(
                'label' => esc_html__('Banner Image', 'artist-painter'),
                'section' => 'artist_painter_slider_section_settings',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    $wp_customize->add_setting( 
        'artist_painter_slider_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'artist_painter_slider_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(ARTIST_PAINTER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'artist_painter_slider_section_settings'
        )
    );

    /** About Section Settings */
    $wp_customize->add_section(
        'artist_painter_about_section_settings',
        array(
            'title' => esc_html__( 'About Us Section', 'artist-painter' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'artist_painter_home_page_settings',
        )
    );

    /** About Section control */
    $wp_customize->add_setting( 
        'artist_painter_about_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_about_setting',
        array(
            'label'       => __( 'About Section', 'artist-painter' ),
            'section'     => 'artist_painter_about_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Extra Title
    $wp_customize->add_setting('artist_painter_featured_mission_section_extra_title', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('artist_painter_featured_mission_section_extra_title', 
        array(
        'label'       => __('Extra Title', 'artist-painter'),
        'section'     => 'artist_painter_about_section_settings',   
        'settings'    => 'artist_painter_featured_mission_section_extra_title',
        'type'        => 'text'
        )
    );

    // Section Title
    $wp_customize->add_setting('artist_painter_featured_mission_section_title', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('artist_painter_featured_mission_section_title', 
        array(
        'label'       => __('Section Title', 'artist-painter'),
        'section'     => 'artist_painter_about_section_settings',   
        'settings'    => 'artist_painter_featured_mission_section_title',
        'type'        => 'text'
        )
    );

     // Section Extra content
    $wp_customize->add_setting('artist_painter_featured_mission_section_extra_content', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('artist_painter_featured_mission_section_extra_content', 
        array(
        'label'       => __('Section Content', 'artist-painter'),
        'section'     => 'artist_painter_about_section_settings',   
        'settings'    => 'artist_painter_featured_mission_section_extra_content',
        'type'        => 'text'
        )
    );

    $wp_customize->add_setting('artist_painter_about_us_video_button_url',array(
        'default' => '',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control('artist_painter_about_us_video_button_url',array(
        'label' => esc_html__('Video Url','artist-painter'),
        'description' => esc_html__( 'Add Embeded URL', 'artist-painter' ),
        'section' => 'artist_painter_about_section_settings',
        'setting' => 'artist_painter_about_us_video_button_url',
        'type'  => 'url'
    ));
    
    /** Socail Section control */
    $wp_customize->add_setting( 
        'artist_painter_banner_social_icon_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_banner_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'artist-painter' ),
            'section'     => 'artist_painter_about_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'artist_painter_banner_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_banner_social_link_1',
        array(
            'label' => esc_html__( 'Facebook Link', 'artist-painter' ),
            'section' => 'artist_painter_about_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'artist_painter_banner_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_banner_social_link_2',
        array(
            'label' => esc_html__( 'Youtube Link', 'artist-painter' ),
            'section' => 'artist_painter_about_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link */
    $wp_customize->add_setting(
        'artist_painter_banner_social_link_5',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_banner_social_link_5',
        array(
            'label' => esc_html__( 'Whatsapp Link', 'artist-painter' ),
            'section' => 'artist_painter_about_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'artist_painter_banner_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_banner_social_link_3',
        array(
            'label' => esc_html__( 'Instagram Link', 'artist-painter' ),
            'section' => 'artist_painter_about_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'artist_painter_banner_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_banner_social_link_4',
        array(
            'label' => esc_html__( 'Telecast Link', 'artist-painter' ),
            'section' => 'artist_painter_about_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link */
    $wp_customize->add_setting(
        'artist_painter_banner_social_link_6',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_banner_social_link_6',
        array(
            'label' => esc_html__( 'Twitter Link', 'artist-painter' ),
            'section' => 'artist_painter_about_section_settings',
            'type' => 'url',
        )
    );

    $wp_customize->add_setting( 
        'artist_painter_about_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'artist_painter_about_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(ARTIST_PAINTER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'artist_painter_about_section_settings'
        )
    );

    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'artist_painter_footer_section',
        array(
            'title' => __( 'Footer Settings', 'artist-painter' ),
            'priority' => 70,
            'panel' => 'artist_painter_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('artist_painter_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'artist_painter_sanitize_choices',
    ));

    $wp_customize->add_control('artist_painter_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'artist-painter'),
        'section'  => 'artist_painter_footer_section',
        'settings' => 'artist_painter_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'artist-painter'),
		   '2'     => __('Two', 'artist-painter'),
		   '3'     => __('Three', 'artist-painter'),
		   '4'     => __('Four', 'artist-painter')
        ),
    ));

    /** Footer Copyright control */
    $wp_customize->add_setting( 
        'artist_painter_footer_setting', 
        array(
            'default' => true,
            'sanitize_callback' => 'artist_painter_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'artist_painter_footer_setting',
        array(
            'label'       => __( 'Show Footer Copyright', 'artist-painter' ),
            'section'     => 'artist_painter_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'artist_painter_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'artist_painter_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'artist-painter' ),
            'section' => 'artist_painter_footer_section',
            'type' => 'text',
        )
    );  

    $wp_customize->add_setting('artist_painter_footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );

    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'artist_painter_footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'artist-painter'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'artist-painter'), 1024, 800),
                'section' => 'artist_painter_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('artist_painter_background_attachment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'artist_painter_sanitize_choices',
    ));

    $wp_customize->add_control('artist_painter_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'artist-painter'),
        'section'  => 'artist_painter_footer_section',
        'settings' => 'artist_painter_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','artist-painter'),
            'scroll' => __('scroll','artist-painter'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'artist_painter_footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'artist_painter_footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'artist-painter'),
                'section' => 'artist_painter_footer_section',
                'type' => 'color',
            )
        )
    );

     $wp_customize->add_setting('artist_painter_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Artist_Painter_Changeable_Icon(
        $wp_customize,'artist_painter_scroll_icon',array(
        'label' => __('Scroll Top Icon','artist-painter'),
        'transport' => 'refresh',
        'section'   => 'artist_painter_footer_section',
        'type'      => 'icon'
    )));

    /** Scroll to top button shape */
    $wp_customize->add_setting('artist_painter_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'artist_painter_sanitize_choices',
    ));

    $wp_customize->add_control('artist_painter_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'artist-painter'),
        'section'  => 'artist_painter_footer_section',
        'settings' => 'artist_painter_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'artist-painter' ),
            'curved-box' => __( 'Curved Box', 'artist-painter' ),
            'circle'     => __( 'Circle', 'artist-painter' ),
        ),
    ));

    $wp_customize->add_setting( 
        'artist_painter_footer_settings_upgraded_features',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control(
        'artist_painter_footer_settings_upgraded_features', 
        array(
            'type'=> 'hidden',
            'description' => "
                <div class='notice-pro-features'>
                    <div class='notice-pro-icon'>
                        <i class='fas fa-crown'></i>
                    </div>
                    <div class='notice-pro-content'>
                        <h3>Unlock Premium Features</h3>
                        <p>Enhance your website with advanced layouts, premium sections, and powerful customization tools.</p>
                    </div>
                    <div class='notice-pro-button'>
                        <a target='_blank' href='". esc_url(ARTIST_PAINTER_URL) ."' class='notice-upgrade-btn'>
                            Upgrade to Pro<i class='fas fa-rocket'></i>
                        </a>
                    </div>
                </div>
            ",
            'section' => 'artist_painter_footer_section'
        )
    );

    /** Footer Social Icon */
    $wp_customize->add_section('artist_painter_footer_social_section', array(
        'title' => __( 'Footer Social Settings', 'artist-painter' ),
        'panel' => 'artist_painter_home_page_settings',
    ));

    $wp_customize->add_setting('artist_painter_enable_footer_icon_section', array(
        'default' => true,
        'sanitize_callback' => 'artist_painter_sanitize_checkbox',
    ) );
    $wp_customize->add_control( 'artist_painter_enable_footer_icon_section', array(
        'label'       => __( 'Show Footer Icon', 'artist-painter' ),
        'section'     => 'artist_painter_footer_social_section',
        'type'        => 'checkbox',
    ));

    // Add setting for Facebook Link
    $wp_customize->add_setting(
        'artist_painter_footer_facebook_link',
        array(
            'default'           => 'https://www.facebook.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'artist_painter_footer_facebook_link',
        array(
            'label'           => esc_html__( 'Facebook Link', 'artist-painter'  ),
            'section'         => 'artist_painter_footer_social_section',
            'settings'        => 'artist_painter_footer_facebook_link',
            'type'      => 'url'
        )
    );

    // Add setting for Facebook Icon Changing
    $wp_customize->add_setting(
        'artist_painter_facebook_icon',
        array(
            'default' => 'fa-brands fa-facebook',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Artist_Painter_Changeable_Icon($wp_customize, 
        'artist_painter_facebook_icon',
        array(
            'label'   		=> __('Facebook Icon','artist-painter'),
            'section' 		=> 'artist_painter_footer_social_section',
            'iconset' => 'fb',
        ))  
    );


    // Add setting for Twitter Link
    $wp_customize->add_setting(
        'artist_painter_footer_twitter_link',
        array(
            'default'           => 'https://twitter.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'artist_painter_footer_twitter_link',
        array(
            'label'           => esc_html__( 'Twitter Link', 'artist-painter'  ),
            'section'         => 'artist_painter_footer_social_section',
            'settings'        => 'artist_painter_footer_twitter_link',
            'type'      => 'url'
        )
    );

    // Add setting for Twitter Icon Changing
    $wp_customize->add_setting(
        'artist_painter_twitter_icon',
        array(
            'default' => 'fa-brands fa-twitter',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Artist_Painter_Changeable_Icon($wp_customize, 
        'artist_painter_twitter_icon',
        array(
            'label'   		=> __('Twitter Icon','artist-painter'),
            'section' 		=> 'artist_painter_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // Add setting for Instagram Link
    $wp_customize->add_setting(
        'artist_painter_footer_instagram_link',
        array(
            'default'           => 'https://www.instagram.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'artist_painter_footer_instagram_link',
        array(
            'label'           => esc_html__( 'Instagram Link', 'artist-painter'  ),
            'section'         => 'artist_painter_footer_social_section',
            'settings'        => 'artist_painter_footer_instagram_link',
            'type'      => 'url'
        )
    );

    // Add setting for Instagram Icon Changing
    $wp_customize->add_setting(
        'artist_painter_instagram_icon',
        array(
            'default' => 'fa-brands fa-instagram',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Artist_Painter_Changeable_Icon($wp_customize, 
        'artist_painter_instagram_icon',
        array(
            'label'   		=> __('Instagram Icon','artist-painter'),
            'section' 		=> 'artist_painter_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // Add setting for Linkedin Link
    $wp_customize->add_setting(
        'artist_painter_footer_linkedin_link',
        array(
            'default'           => 'https://in.linkedin.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'artist_painter_footer_linkedin_link',
        array(
            'label'           => esc_html__( 'Linkedin Link', 'artist-painter'  ),
            'section'         => 'artist_painter_footer_social_section',
            'settings'        => 'artist_painter_footer_linkedin_link',
            'type'      => 'url'
        )
    );

    // Add setting for Linkedin Icon Changing
    $wp_customize->add_setting(
        'artist_painter_linkedin_icon',
        array(
            'default' => 'fa-brands fa-linkedin',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Artist_Painter_Changeable_Icon($wp_customize, 
        'artist_painter_linkedin_icon',
        array(
            'label'   		=> __('Linkedin Icon','artist-painter'),
            'section' 		=> 'artist_painter_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // Add setting for Youtube Link
    $wp_customize->add_setting(
        'artist_painter_footer_youtube_link',
        array(
            'default'           => 'https://www.youtube.com/',
            'sanitize_callback' => 'esc_url_raw',
        )
    );

    $wp_customize->add_control(
        'artist_painter_footer_youtube_link',
        array(
            'label'           => esc_html__( 'Youtube Link', 'artist-painter'  ),
            'section'         => 'artist_painter_footer_social_section',
            'settings'        => 'artist_painter_footer_youtube_link',
            'type'      => 'url'
        )
    );

    // Add setting for Youtube Icon Changing
    $wp_customize->add_setting(
        'artist_painter_youtube_icon',
        array(
            'default' => 'fa-brands fa-youtube',
            'sanitize_callback' => 'sanitize_text_field',
            'capability' => 'edit_theme_options',
            
        )
    );	

    $wp_customize->add_control(new Artist_Painter_Changeable_Icon($wp_customize, 
        'artist_painter_youtube_icon',
        array(
            'label'   		=> __('Youtube Icon','artist-painter'),
            'section' 		=> 'artist_painter_footer_social_section',
            'iconset' => 'fb',
        ))  
    );

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'artist_painter_404_section',
        array(
            'title' => __( '404 Page Settings', 'artist-painter' ),
            'priority' => 70,
            'panel' => 'artist_painter_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'artist-painter'),
        'section' => 'artist_painter_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'artist-painter'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('404 Page Heading', 'artist-painter'),
        'section' => 'artist_painter_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'artist-painter'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('404 Page Content', 'artist-painter'),
        'section' => 'artist_painter_404_section',
    ));

}
add_action( 'customize_register', 'artist_painter_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function artist_painter_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $artist_painter_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $artist_painter_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'artist_painter_customizer', get_template_directory_uri() . '/js' . $artist_painter_build . '/customizer' . $artist_painter_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'artist_painter_customize_preview_js' );